package za.co.symbiotics.test.mdb;

import javax.jms.DeliveryMode;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import javax.jms.TopicPublisher;
import javax.jms.TopicSession;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;

import za.co.symbiotics.seam.test.entity.TestEntity;

@Name("testMessageDrivenBean")
@MessageDriven(activationConfig = { @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"), @ActivationConfigProperty(propertyName = "destination", propertyValue = "queue/feedQueue") })
public class TestMessageDrivenBean implements MessageListener {

    @Resource
    private MessageDrivenContext mdc;

    @PersistenceContext
    protected EntityManager entityManager;

    @In
    private TopicPublisher topicPublisher;

    @In
    private TopicSession topicSession;

    public void onMessage(Message msg) {

        try {
            String value1 = msg.getStringProperty("value1");
            String value2 = msg.getStringProperty("value2");
            TestEntity entity = new TestEntity();
            entity.setValue1(value1);
            entity.setValue2(value2);
            entityManager.persist(entity);
            TextMessage text = topicSession.createTextMessage();
            text.setLongProperty("entityId", entity.getId());
            text.setStringProperty("entityClass", entity.getClass().getCanonicalName());
            topicPublisher.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
            topicPublisher.publish(text);
        } catch (JMSException e) {
            e.printStackTrace();
            mdc.setRollbackOnly();
        }
    }
}
