package za.co.symbiotics.test.mdb;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.log.Log;

import za.co.symbiotics.test.handler.TopicHandler;

@Name("topicMessageDrivenBean")
@MessageDriven(activationConfig = { @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"), @ActivationConfigProperty(propertyName = "destination", propertyValue = "topic/eventTopic") })
public class TopicMessageDrivenBean implements MessageListener {

    @Logger
    Log logger;
    @PersistenceContext
    EntityManager entityManager;

    @Resource
    MessageDrivenContext mdc;

    @In
    TopicHandler topicHandler;

    public void onMessage(Message msg) {
        try {
            // Thread.sleep(5000); // TODO uncomment to ensure the JPA/JDBC transaction has also committed
            Long id = msg.getLongProperty("entityId");
            String className = msg.getStringProperty("entityClass");
            logger.info("Loading:#0:#1", className, id);
            Object obj = entityManager.find(Class.forName(className), id);
            topicHandler.handleEvent(obj);
        } catch (Exception e) {
            e.printStackTrace();
            mdc.setRollbackOnly();
        }
    }

}
